#!/usr/bin/perl -w
use strict;
use utf8;
use encoding 'utf8';

# 単語を TeX ディレクトリの中で探す
# 17 行あたりの /****/ で検索文字列を設定
# ファイル，行番号，行の内容，が出力されるので，
# "ファイル > 選択名の文書を開く" メニューでファイルを開く．

sub ParseFile($) {
	my ($path) = @_;
	open(IN, "<:bytes", $path) or die;
	my @list = ();
	while (<IN>) {
# pattern
		next unless (/\\because/);
		chomp;
		push(@list, "$.: $_");
	}
	close(IN);
	print "$path\n" . join("\n", @list) . "\n" if (@list);
}

my $Dir = $ENV{'JTeXEditTeXBinPath'};
$Dir =~ s|/[^/]*$|/share|;
opendir(DIR, $Dir) or die;
my @texmf = readdir(DIR);
closedir(DIR);

print "\nSearch in $Dir\n\n";

sub ParseDir($);
sub ParseDir($) {
	my ($dir) = @_;
#	print "dir = $dir\n";
	opendir(DIR, $dir) or die;
	my @items = readdir(DIR);
	closedir(DIR);
	for (@items) {
		next if (/^\./);
		my $path = "$dir/$_";
		if (-d $path) {
			ParseDir($path);
		} else {
			ParseFile($path);
		}
	}
}

for (@texmf) {
	next unless (/^texmf/);
	my $tex = "$Dir/$_/tex";
	ParseDir($tex) if (-d $tex);
}
