#!/usr/bin/perl -w
use utf8;

# 正規表現による文書内容検索

# 使用法:
#	16 行目の pattern を修正して，このウィンドウにフォルダを落とすと，
#		pattern に一致する行を ***.fnd に記録する．
#	18 行目の '' を ".found" にすれば結果は ファイル名.found に出力される．
#	SJIS または UTF-8 形式のファイルの場合は，12 行目に # をつけて，13 行目，または 14 行目の # を削除すること．

use strict;
use Foundation;
# man PerlObjCBridge

use open IN => 'bytes';
#use open IN => ':encoding(shift_jis)';
#use open IN => 'utf8';
sub Match($) {
	return $_[0] =~ /TEXT/o; # pattern
}
my $Out = ''; #".found";

sub CheckFileName($) {
	return 1;
	return $_[0] =~ /\.pl$/;
}

my %Ignore = ('.' => 1, '..' => 1, "Icon\r" => 1, "Icon\n" => 1);
my $Debug = 1;
sub CheckEOL();

sub DoFile($) {
	my ($file) = @_;
	return "" if (-l $file or not CheckFileName($file));
	warn "open $file\n" if $Debug;
	unless (open(IN, $file)) {
		warn "can't open file '$file': $!\n";
		return;
	}
	CheckEOL();
	my $found = '';
	while (my $line = <IN>) {
		next unless (Match($line));
		unless ($found) {
			$found = 1;
			print "\n" unless $Out;
			print "$file\n";
			print OUT "\n**** $file\n" if $Out;
		}
		if ($Out) { print OUT $., "  ", $line; }
		else { print $., "  ", $line; }
	}
	close IN;
}

sub CheckEOL() {
	my $buff;
	read(IN, $buff, 1024);
	seek(IN, 0, 0);
	$/ = ($buff =~ /\n/) ? "\n" : "\r";
}

sub Scan($);
sub Scan($) {
	my ($obj) = @_;
	return if (-l $obj);
	if (-d $obj) {
		unless (opendir(DIR, $obj)) {
			warn "can't scan '$obj': $!\n";
			return;
		}
		my @items = readdir DIR;
		closedir DIR;
		for my $item (@items) {
			next if ($item =~ /^\./);
			Scan("$obj/$item") unless $Ignore{$item};
		}
	} else {
		DoFile $obj;
	}
}

sub SetFileTypes($) {
	my ($path) = @_;
	my $sign = NSNumber->numberWithInt_(unpack("N", 'jtxE'));
	my $type = NSNumber->numberWithInt_(unpack("N", 'utf8'));
	my $dict = NSMutableDictionary->dictionary;
	$dict->setObject_forKey_($sign, "NSFileHFSCreatorCode");
	$dict->setObject_forKey_($type, "NSFileHFSTypeCode");
	NSFileManager->defaultManager
		->changeFileAttributes_atPath_($dict, $path);
}

while (my $dir = shift) {
	print "\n**** Find in $dir\n";
	if ($Out) {
		unless (open(OUT, ">$dir$Out")) {
			warn "Can't open dir '$dir$Out': $!\n";
			next;
		}
		Scan $dir;
		print "**** Result: '$dir$Out'\n";
		close(OUT);
		SetFileTypes("$dir$Out");
	} else {
		Scan $dir;
	}
}

print "**** end of find ****\n";

