#! /usr/bin/perl -w
use strict;
use utf8;
use encoding 'utf8';

use Foundation;
# man PerlObjCBridge

# ファイルの情報を表示する．

sub GetFileTypes($) {
	my ($path) = @_;
	my $dict = NSFileManager->defaultManager
		->attributesOfItemAtPath_error_($path, undef);
	my $sign = $dict->objectForKey_("NSFileHFSCreatorCode")->unsignedLongValue;
	$sign = $sign ? pack("N", $sign) : '';
	my $type = $dict->objectForKey_("NSFileHFSTypeCode")->unsignedLongValue;
	$type = $type ? pack("N", $type) : '';
	return ($sign, $type);
}

sub GetFileInfo($) {
	my ($path) = @_;
	my $dict = NSFileManager->defaultManager
		->attributesOfItemAtPath_error_($path, undef);
	my $filesize = $dict->objectForKey_("NSFileSize")->unsignedLongLongValue;
	my $mtime = $dict->objectForKey_("NSFileModificationDate")->description->UTF8String;
	my $ctime = $dict->objectForKey_("NSFileCreationDate")->description->UTF8String;
	my $rsrcsize = 0;
	$dict = NSFileManager->defaultManager
		->attributesOfItemAtPath_error_("$path/rsrc", undef);
	$rsrcsize = $dict->objectForKey_("NSFileSize")->unsignedLongLongValue if ($dict);
	return ($filesize, $rsrcsize, $ctime, $mtime);
}

while (my $path = shift) {
	my ($sign, $type) = GetFileTypes($path);
	my ($filesize, $rsrcsize, $ctime, $mtime) = GetFileInfo($path);
	my $totalsize = $filesize + $rsrcsize;
	print "$path:\n\tcreator = '$sign', filetype = '$type',\n\tfilesize = $filesize, rsrcsize = $rsrcsize, totalsize = $totalsize\n\tcreation = $ctime, modification = $mtime\n";
}
