#! perl -w
##########################################################
#	ps file to pdf file converter script
#	by N. KOISO
#	version 1.3
#	usage: perl PStoPDF.pl ps_file
#	require gs program
##########################################################
#	version 1.3		didn't return if reached last, allow non "EPSF-1.2"
#	version 1.2		deleted -dNODISPLY
#	version 1.1		allow % comments between '!PS-Adobe' and 'BoundingBox'
#	version 1.0		first release
##########################################################

my $Src = $ARGV[0];
open(IN, "<:bytes", $Src) or die "can't open '$Src'";
my $Buff = '';
sub ReadLine() { # Mac or Unix
	for (;;) {
		return $1 if ($Buff =~ s/^(.*?)(\n|\r)//);
		my $buff = '';
		my $len = read(IN, $buff, 1024);
		$Buff .= $buff;
		last if ($len < 1024);
	}
	return $1 if ($Buff =~ s/^(.*?)(\n|\r)//);
	die "'$Src' is not ps file." unless length($Buff);
	my $buff = $Buff;
	$Buff = '';
	return $buff;
}
#	%%!PS-Adobe-2.0 EPSF-1.2
#	%%BoundingBox: 0 0 288 261
#	%%HiResBoundingBox: 0 0 288 261.125
my ($Width, $Height);
TRY:
for (;;) {
	do {}
	while (ReadLine() !~ /^%+!PS-Adobe-\d+\.\d/);
	for (;;) {
		my $line = ReadLine();
		next TRY unless ($line =~ /^%/);
		$line =~ /^%+BoundingBox:\s+-?\d+\s+-?\d+\s+(-?\d+)\s+(-?\d+)/ or next;
		($Width, $Height) = ($1, $2);
		($Width, $Height) = ($1, $2)
			if (ReadLine() =~ /^%+HiResBoundingBox:\s+[-.\d]+\s+[-.\d]+\s+([-.\d]+)\s+([-.\d]+)/);
		last TRY;
	}
}
close(IN);
my $Size = int($Width * 10 + 0.999).'x'.int($Height * 10 + 0.999);
my ($Dir, $Name) = $Src =~ m|^(.*)/([^/]*)$|;
chdir($Dir) or die "can't chdir '$Dir'.";
my $Trg = $Name;
$Trg =~ s|\.[^.]*$||;
$Trg .= '.pdf';
sub FindGS() {
	my $envpath = $ENV{'PATH'};
	my @addpath = split(':', '~/bin:/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/usr/sbin:/sbin');
	@addpath = grep($envpath !~ /(^|:)$_(:|$)/, @addpath);
	my @envpath = split(':', $envpath);
	push(@envpath, @addpath);
	for my $dir (@envpath) {
		opendir(DIR, $dir) or next;
		while (my $name = readdir(DIR)) {
			my $path = "$dir/$name";
			return $path if ($name eq 'gs' and -x $path and not -d $path);
		}
	}
	die "can't find gs program\nin \$ENV{PATH}='$envpath'\n$!\n";
}
sub GetGS() {
	my $dat = $0;
	$dat =~ s/\.pl$/\.data/;
	if (open(IN, "<:bytes", $dat)) {
		my $gs = <IN>;
		close(IN);
		chomp($gs);
		return $gs if (-x $gs and not -d $gs);
	}
	my $path = FindGS();
	if (open(OUT, ">:bytes", $dat)) {
		print OUT $path, "\n";
		close(OUT);
	}
	return $path;
}
my $GSPath = GetGS();
#	gs -sDEVICE=pdfwrite -dBATCH -dNOPAUSE -g2880x2610 -sOutputFile=enneper.pdf enneper
#	-dNODISPLAY ?
my $Err = system($GSPath." -sDEVICE=pdfwrite -dBATCH -dNOPAUSE -g$Size -sOutputFile='".$Trg."' '".$Name."'");
exit $Err;
