#! /usr/bin/perl -w
use strict;
use utf8;
use encoding 'utf8';

# 行を分解する

# 文章をこのウィンドウに落とす

my $NumChars = 80; # 1 行の文字数, 全角文字は 2 文字に数える.

# U-2150 (数字に準じるもの) 以上を全角と見なす
sub Zenkaku($) { return ord($_[0]) >= 0x2150; }

sub Resplit($$) {
	my ($out, $line) = @_;
	my $right = substr($line, 0, 1);
	my ($i, $left);
	for ($i = length($out) - 1; $i >= 0; --$i, $right = $left) {
		$left = substr($out, $i, 1);
		last if ($left =~ /\s/ or $right =~ /\s|[[({]/);
		next if ($right =~ /[])}.,;!?'"`]/ or $left =~ /[[({'"]/);
		last if (Zenkaku($left) or Zenkaku($right));
	}
	if ($i > 0) {
		$line = substr($out, $i + 1) . $line;
		$out = substr($out, 0, $i + 1);
		$out = substr($out, 0, -1) if ($left eq ' ');
	}
	return ($out, $line);
}

print "\nLinesSplit\n";

my $File = shift or die;
open(IN, $File) or die $!;
while (my $line = <IN>) {
	my $count = $NumChars;
	my $out = '';
	chomp $line;
	while ($line) {
		my $c = substr($line, 0, 1);
		$line = substr($line, 1);
		--$count;
		--$count if (Zenkaku($c));
		if ($count > 0) {
			$out .= $c;
			next;
		}
		if ($count < 0) { $line = "$c$line"; } # push back
		else { $out .= $c; }
		($out, $line) = Resplit($out, $line) if ($line);
		print "$out\n";
		$out = '';
		$count = $NumChars;
	}
	print "$out\n" if length($out);
	print "\n";
}
