#! /usr/bin/perl -w
use strict;
use utf8;
use encoding 'utf8';

use Foundation;
# man PerlObjCBridge

# ファイルの製造ソフト (c) と種類 (t) を表示する．

sub GetFileType($) {
	my ($path) = @_;
	my $dict = NSFileManager->defaultManager
		->attributesOfItemAtPath_error_($path, undef);
	my $sign = $dict->objectForKey_("NSFileHFSCreatorCode")->intValue;
	$sign = $sign ? pack("N", $sign) : '';
	my $type = $dict->objectForKey_("NSFileHFSTypeCode")->intValue;
	$type = $type ? pack("N", $type) : '';
	return ($sign, $type);
}

while (my $path = shift) {
	my ($sign, $type) = GetFileType($path);
	print "$path: c = $sign, t = $type\n";
}
