#! /usr/bin/perl -w
use strict;
use utf8;
use encoding 'utf8';

# arguments: pfb, tfm, pfb, tfm, ...

my $WorkDir = "$ENV{'HOME'}/Desktop/FontForgeFonts";
unless (-e $WorkDir) {
	mkdir($WorkDir) or die "Can't create temp directory: $WorkDir";
}

sub PrintScript($) {
	my ($path) = @_;
	my $script =<<EOS;
#!/usr/local/bin/fontforge
i = 1
while (i < \$argc)
	Open(\$argv[i])
	MergeKern(\$argv[i+1])
	if (\$order == 2)
		SetFontOrder(3)
		SelectAll()
		Simplify(128+32+8, 1.5)
		ScaleToEm(1000)
	endif
	Generate(\$argv[i+2])
	i = i + 3
endloop
EOS
	open(OUT, ">$path") or die;
	print OUT $script;
	close(OUT);
}

# main
{
	my @names;
	my $scriptpath = "$WorkDir/FontForgeScript.pe";
	PrintScript($scriptpath);
	my $shell = "fontforge '$scriptpath'";
	while (my $pfb = shift) {
		my $tfm = shift;
		my ($name, $type, $str);
		($name, $type) = $pfb =~ m|/([^/]*)\.([^./]*)$|;
		if ($type ne 'pfb') { die "Bad argument: $pfb. must be pfb."; }
		$tfm =~ m|/([^/]*)$|;
		if ($1 ne "$name.tfm") { die "Bad argument: $tfm. must be $name.tfm."; }
		my $trg = "$WorkDir/$name.otf";
		push(@names, $name);
		$shell .= " '$pfb' '$tfm' '$trg'";
	}
	my $result = `$shell`;
	for (@names) {
		print "$WorkDir/$_.otf\n" if (-e "$WorkDir/$_.otf");
	}
}
